<?php
if (session_status() === PHP_SESSION_NONE){session_start();}
include 'config.php';
$restURL = $currentPwd = $confirmPwd = "";
$restURLErr = $currentPwdErr = $confirmPwdErr = "" ;
if ($_SERVER["REQUEST_METHOD"] == "POST") {
  $valid = true;
  // Check if restURl is valid
  if (empty($_POST["restURL"])) {
    $restURLErr = "URL is required";
    $valid  = false;
  } else {
    $restURL = test_input($_POST["restURL"]);
  }
  // Check confirm Pwd is valid, only for initial config
  if(isset($_POST['confirmPwd']) && $installed == 0){
    if (empty($_POST["confirmPwd"]) || ($_POST["confirmPwd"] != $_POST["currentPwd"])) {
      $confirmPwdErr = "Password not valid";
      $valid  = false;
    } else {
      $confirmPwd = test_input($_POST["confirmPwd"]);
    }
  }
  // Check if password is valid, only after inital config 
  if(!isset($_POST['confirmPwd']) && $installed > 0){
    if (md5($_POST['currentPwd']) != $pwd || empty($_POST["currentPwd"])) {
      $currentPwdErr = "Password not valid";
      $valid  = false;
    } else {
      $pwd = test_input($_POST["currentPwd"]);
    }
  }
  if ($valid  == true) {
    ini_set('opcache.enable', '0');
    $newPwd = $pwd;
    $baseURL = getBaseUrl();
    if(isset($_POST['confirmPwd']) && $installed == 0){
      $newPwd = $_POST['confirmPwd'];
    }
    setConfig($_POST['restURL'], $newPwd);
    if($installed == 1){
      $_SESSION["init"] = 2;
    } else {
      $_SESSION["init"] = 1;
    }
    header("Location: " . $baseURL . "/");
  }
}
function test_input($data)
{
  $data = trim($data);
  $data = stripslashes($data);
  $data = htmlspecialchars($data);
  return $data;
}
function setConfig($restURL, $pwd)
{
  $_SESSION["restURL"] = $restURL;
  $configFile = 'config.php';
  $handle = fopen($configFile, 'w') or die('Cannot open file:  ' . $configFile); //implicitly creates file
  $written =
    '<?php' . "\n" .
    '// Password needed for executing updates or running install.php after initial setup' . "\n" .
    '$pwd = ' . "'" .  md5($pwd) . "'" . ";" . "\n" .
    '// Initial = 0, Installed = 1' . "\n" .
    '$installed = 1;' . "\n" .
    '// The following is the Allegra server address' . "\n" .
    '$restURL = ' . "'" . $restURL . "'" . ";" . "\n" .
    "?>";
  fwrite($handle, $written);
  fclose($handle);
}
function redirect($baseURL)
{
  error_reporting(E_ALL | E_WARNING | E_NOTICE);
  ini_set('display_errors', TRUE);
  flush();
  header("Location: " . $baseURL);
  die('should have redirected by now');
}

function isSSL()
{
  if (isset($_SERVER['HTTP_X_FORWARDED_PROTO']) && $_SERVER['HTTP_X_FORWARDED_PROTO'] === 'https') {
    return true;
  }
  if (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on') {
    return true;
  }
  return false;
}

function getBaseURL()
{
  $connectViaSSL = isSSL();
  $contextURL = $_SERVER['REQUEST_URI'];
  $pos = strpos($contextURL, "/", 1);
  if ($pos > 0) {
    $contextURL = substr($contextURL, 0, $pos);
  }
  $baseURL = ($connectViaSSL ? "https" : "http") . "://{$_SERVER['HTTP_HOST']}" . $contextURL;
  return $baseURL;
}
?>
<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <!-- Add icon library -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <style>
      body {
        font-family: Arial, Helvetica, sans-serif;
      }

      * {
        box-sizing: border-box;
      }

      .input-container {
        display: -ms-flexbox;
        /* IE10 */
        display: flex;
        width: 100%;
        margin-top: 8px;
        margin-bottom: 16px;
      }

      .icon {
        padding: 10px;
        background: dodgerblue;
        color: white;
        min-width: 50px;
        text-align: center;
      }

      .input-field {
        width: 100%;
        padding: 10px;
        outline: none;
      }

      .input-field:focus {
        border: 2px solid dodgerblue;
      }

      /* Set a style for the submit button */
      .btn {
        margin-top: 8px;
        background-color: dodgerblue;
        color: white;
        padding: 15px 20px;
        border: none;
        cursor: pointer;
        width: 100%;
        opacity: 0.9;
      }

      .btn:hover {
        opacity: 1;
      }

      .error {
        color: red;
        font-size: 14;
      }

      .headline {
        text-align: center;
        margin-top: 15%;
      }

      .description {
        font-size: small;
      }
    </style>
  </head>
  <body>
    <form method="post" action="" style="max-width:500px;margin:auto">
      <h2 class="headline">Initial setup</h2>
      <p class="description"> Type in your REST backend, make sure it's activated in your Allegra server settings. You can run this script again whenever you want to change your backend </p>
      <span class="error"> <?php echo $restURLErr; ?></span>
      <div class="input-container">
        <i class="fa fa-server icon"></i>
        <input class="input-field" type="text" placeholder="https://www.trackplus.com/track-demo" name="restURL" value="<?php echo $restURL; ?>">
      </div>
      <span class="error"> <?php echo $currentPwdErr; ?></span>
      <div class="input-container">
        <i class="fa fa-key icon"></i>
        <?php if($installed == 0): ?>
          <input class="input-field" type="password" placeholder="Type in your initial password" name="currentPwd" value="<?php echo $currentPwd; ?>">
        <?php else: ?>
          <input class="input-field" type="password" placeholder="Your password" name="currentPwd" value="<?php echo $currentPwd; ?>">
        <?php endif; ?>
      </div>
      <?php if($installed == 0): ?>
        <span class="error"> <?php echo $confirmPwdErr; ?></span>
      <div class="input-container">
        <i class="fa fa-key icon"></i>
        <input class="input-field" type="password" placeholder="Confirm your initial password" name="confirmPwd" value="<?php echo $confirmPwd; ?>">
      </div>
      <?php endif; ?>
      <button type="submit" name="submit" class="btn">Finish</button>
    </form>
  </body>
